package cat.hack3.codingtests.marsrover;

import cat.hack3.codingtests.marsrover.api.RotableRiderRover.Rotation;
import cat.hack3.codingtests.marsrover.cartography.Coordinates;
import cat.hack3.codingtests.marsrover.cartography.Direction;

import java.util.logging.Logger;

public class RoverActionReporter {
    Logger logger = Logger.getLogger(this.getClass().getName());

    private static final String OBSTACLE_REPORT_MESSAGE = "There is an obstacle at %s, therefore I will keep the same position";
    private static final String MOVEMENT_REPORT_MESSAGE = "Updated coordinates towards %s, now is %s-%s";
    public static final String ROTATION_REPORT_MESSGE = "Rotated towards %s, now the direction is %s";

    public void reportObstacle(Coordinates newPosition) {
        var collisionReport = String.format(OBSTACLE_REPORT_MESSAGE, newPosition);
        logger.info(collisionReport);
    }

    public void reportMovement(Direction direction, Coordinates newPosition) {
        String movementReport = String.format(MOVEMENT_REPORT_MESSAGE,
                direction, newPosition.latitude(), newPosition.longitude());
        logger.info(movementReport);
    }

    public void reportRotation(Rotation rotation, Direction newDirection) {
        logger.info(String.format(ROTATION_REPORT_MESSGE,
                rotation, newDirection));
    }
}
