package cat.hack3.codingtests.marsrover.commands.api;


import cat.hack3.codingtests.marsrover.api.RotableRiderRover;
import cat.hack3.codingtests.marsrover.commands.MoveBackwardsCommand;
import cat.hack3.codingtests.marsrover.commands.MoveForwardCommand;
import cat.hack3.codingtests.marsrover.commands.TurnLeftCommand;
import cat.hack3.codingtests.marsrover.commands.TurnRightCommand;

public class CommandFactory {
    private final RotableRiderRover rover;

    public CommandFactory(RotableRiderRover rover) {
        this.rover = rover;
    }

    public RoverCommand createCommand(RoverCommand.Type type) {
        return switch (type) {
            case MOVE_FORWARD -> new MoveForwardCommand(rover);
            case MOVE_BACKWARDS -> new MoveBackwardsCommand(rover);
            case TURN_LEFT -> new TurnLeftCommand(rover);
            case TURN_RIGHT -> new TurnRightCommand(rover);
        };
    }
}
