package cat.hack3.codingtests.marsrover.ui.console;

import cat.hack3.codingtests.marsrover.RotableRiderRover;

import java.util.Scanner;

import static cat.hack3.codingtests.marsrover.ui.console.UICommons.output;

public class ClientCommandInterface {

    private final Scanner reader;
    private final RoverInitializer roverInitializer;

    public static void main(String[] args) {
        try (var userInputSource = new Scanner(System.in)) {
            new ClientCommandInterface(userInputSource)
                    .start();
        }
    }

    public ClientCommandInterface(Scanner userInputSource) {
        reader = userInputSource;
        roverInitializer = new RoverInitializer(reader);
    }

    private void start() {
        output(PresentationMessage.INTRO);

        //RotableRiderRover rover = roverInitializer.autoInitialize();
        RotableRiderRover rover = roverInitializer.initializeFromUserInputs();

        var commandsPerformer = new RoverCommandsPerformer(reader, rover);
        commandsPerformer.acceptCommandsUntilExitSignal();
    }

}
